Skip to main content
POST
/
api
/
v2
/
workspace
cURL
curl --request POST \
  --url https://us.infisical.com/api/v2/workspace \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "projectName": "<string>",
  "projectDescription": "<string>",
  "slug": "<string>",
  "kmsKeyId": "<string>",
  "template": "default",
  "type": "secret-manager",
  "shouldCreateDefaultEnvs": true,
  "hasDeleteProtection": false
}
'
import requests

url = "https://us.infisical.com/api/v2/workspace"

payload = {
    "projectName": "<string>",
    "projectDescription": "<string>",
    "slug": "<string>",
    "kmsKeyId": "<string>",
    "template": "default",
    "type": "secret-manager",
    "shouldCreateDefaultEnvs": True,
    "hasDeleteProtection": False
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    projectName: '<string>',
    projectDescription: '<string>',
    slug: '<string>',
    kmsKeyId: '<string>',
    template: 'default',
    type: 'secret-manager',
    shouldCreateDefaultEnvs: true,
    hasDeleteProtection: false
  })
};

fetch('https://us.infisical.com/api/v2/workspace', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "project": {
    "id": "<string>",
    "name": "<string>",
    "type": "<string>",
    "slug": "<string>",
    "orgId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "createdAt": "2023-11-07T05:31:56Z",
    "updatedAt": "2023-11-07T05:31:56Z",
    "_id": "<string>",
    "environments": [
      {
        "name": "<string>",
        "slug": "<string>",
        "id": "<string>"
      }
    ],
    "description": "<string>",
    "defaultProduct": "<string>",
    "autoCapitalization": false,
    "version": 1,
    "upgradeStatus": "<string>",
    "pitVersionLimit": 10,
    "kmsCertificateKeyId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "auditLogsRetentionDays": 123,
    "hasDeleteProtection": false,
    "secretSharing": true,
    "showSnapshotsLegacy": false,
    "secretDetectionIgnoreValues": [
      "<string>"
    ],
    "enforceEncryptedSecretManagerSecretMetadata": true,
    "kmsSecretManagerKeyId": "<string>"
  }
}
{
  "reqId": "<string>",
  "statusCode": 400,
  "message": "<string>",
  "error": "<string>",
  "details": "<unknown>"
}
{
  "reqId": "<string>",
  "statusCode": 401,
  "message": "<string>",
  "error": "<string>"
}
{
  "reqId": "<string>",
  "statusCode": 403,
  "message": "<string>",
  "error": "<string>",
  "details": "<unknown>"
}
{
  "reqId": "<string>",
  "statusCode": 404,
  "message": "<string>",
  "error": "<string>"
}
{
  "reqId": "<string>",
  "statusCode": 422,
  "error": "<string>",
  "message": "<unknown>"
}
{
  "reqId": "<string>",
  "statusCode": 500,
  "message": "<string>",
  "error": "<string>"
}

Authorizations

Authorization
string
header
required

An access token in Infisical

Body

application/json
projectName
string
required

The name of the project to create.

Maximum string length: 64
projectDescription
string

An optional description label for the project.

Maximum string length: 1024
slug
string

An optional slug for the project.

Required string length: 5 - 36
kmsKeyId
string
template
string
default:default

The name of the project template, if specified, to apply to this project.

Required string length: 1 - 64
type
enum<string>
default:secret-manager
Available options:
secret-manager,
cert-manager,
kms,
ssh,
secret-scanning,
pam,
ai
shouldCreateDefaultEnvs
boolean
default:true
hasDeleteProtection
boolean
default:false

Response

Default Response

project
object
required